#Include Once "gui.bi"

Enum Boolean
	FALSE
	TRUE
End Enum

Enum TState
	normal
	activated
	blocked
End Enum

Type TPoint
	x As Integer
	y As Integer
End Type

Type TWord
	word As String
	question As String
	found As Boolean
	pos1 As TPoint
	pos2 As TPoint
End Type

Type TField
	char As String * 1
	locked As Boolean
	state As TState
End Type

Dim Shared lastClick As TPoint
ReDim Shared words () As String
ReDim Shared questions () As String
Dim Shared question As String
Dim Shared selected (10) As TWord
Dim Shared charField (20 , 20) As TField


Declare Function comparePoints (a As TPoint , b As TPoint) As Boolean

Declare Sub getWords (filename As String)
Declare Function decode (text As String , key As Integer) As String

Declare Sub generateNew

Declare Sub drawField

Declare Sub mouseClick (mouse As TPoint)


Function comparePoints (a As TPoint , b As TPoint) As Boolean
	If a.x = b.x And a.y = b.y Then Return TRUE
	Return FALSE
End Function

Sub getWords (filename As String)
	Dim row As String
	Dim position As Integer
	
	ReDim words (0)
	Open filename For Binary As #1
		Line Input #1 , row
		Line Input #1 , row
		question = decode (row , 10)
		Do
			Line Input #1 , row
			row = decode (row , 10)
			ReDim Preserve words (UBound (words) + 2)
			ReDim Preserve questions (UBound (questions) + 2)
			
			position = InStr (row , ";")
			
			words (UBound (words)) = Mid (row , 1 , position - 1)
			questions (UBound (questions)) = Mid (row , position + 2)
		Loop Until Eof (1)
	Close #1
End Sub

Function decode (text As String , key As Integer) As String
	For x As Integer = 0 To Len (text) - 1
		text [x] -= key
	Next
	
	Return text
End Function

Sub generateNew
	Dim last (10) As Integer
	Dim rndNumber As Integer
	Dim flag As Boolean
	Dim pos1 As TPoint
	Dim pos2 As TPoint
	Dim orientation As Byte
	Dim word As String
	
	For x As Integer = 0 To 19
		For y As Integer = 0 To 19
			charField(x , y).char = ""
			charField(x , y).state = TState.normal
			charField(x , y).locked = FALSE
		Next
	Next
	
	For x As Integer = 0 To 9
		Do
			flag = FALSE
			
			rndNumber = Int (Rnd * UBound (words))
			For x As Integer = 0 To 9
				If rndNumber = last (x) Then
					flag = TRUE
					Exit For
				EndIf
			Next
			
			If flag = FALSE And words(rndNumber) <> "" Then Exit Do
		Loop
		last (x) = rndNumber
		selected(x).word = words (rndNumber)
		selected(x).question = questions (rndNumber)
		selected(x).found = FALSE
		flag = FALSE
		word = words (rndNumber)
		Do
			flag = FALSE
			orientation = Int (Rnd * 2)
			If orientation = 0 Then 'vertical
				pos1.x = Int (Rnd * 20)
				pos1.y = Int (Rnd * (20 - Len (selected(x).word)))
				
				pos2.x = pos1.x
				pos2.y = pos1.y + Len (selected(x).word) - 1
				For y As Integer = 0 To pos2.y - pos1.y
					If charField (pos1.x , pos1.y + y).char <> "" And charField (pos1.x , pos1.y + y).char <> Chr (word[y]) Then
						flag = TRUE 
						Exit For
					EndIf
				Next
				
				If flag = FALSE Then
					For y As Integer = 0 To Len (word) - 1
						charField (pos1.x , pos1.y + y).char = Chr (word[y])
						'charField (pos1.x , pos1.y + y).state = TState.activated
					Next
					
					selected (x).pos1 = pos1
					selected (x).pos2 = pos2
					Exit Do
				EndIf
			Else 'horizontal
				pos1.x = Int (Rnd * (20 - Len (selected(x).word)))
				pos1.y = Int (Rnd * 20)
				
				pos2.x = pos1.x + Len (selected(x).word) - 1
				pos2.y = pos1.y
				For y As Integer = 0 To pos2.x - pos1.x
					If charField (pos1.x + y , pos1.y).char <> "" And charField (pos1.x + y , pos1.y).char <> Chr (word[y]) Then
						flag = TRUE
						Exit For
					EndIf
				Next
				
				If flag = FALSE Then
					For y As Integer = 0 To Len (word) - 1
						charField (pos1.x + y , pos1.y).char = Chr (word[y])
						'charField (pos1.x + y , pos1.y).state = TState.activated
					Next
					
					selected (x).pos1 = pos1
					selected (x).pos2 = pos2
					Exit Do
				EndIf
			EndIf
		Loop
		
	Next
	
	
	
	For x As Integer = 0 To 19
		For y As Integer = 0 To 19
			If charField (x , y).char = "" Then 
				charField (x , y).char = Chr (Int (Rnd * 24) + 65)
			EndIf
		Next
	Next
	
	lastClick.x = -1
	lastClick.y = -1
End Sub

Sub drawField
	For x As Integer = 0 To 19
		For y As Integer = 0 To 19
			Line (x * 30 , y * 30) - ((x + 1) * 30 , (y + 1) * 30) , RGB (0 , 0 , 0) , B
			If charField (y , x).state = TState.activated Then
				Line (x * 30 + 1 , y * 30 + 1) - ((x + 1) * 30 - 1 , (y + 1) * 30 - 1) , RGB (255 , 255 , 0) , BF
			ElseIf charField (y , x).state = TState.blocked Then
				Line (x * 30 + 1 , y * 30 + 1) - ((x + 1) * 30 - 1 , (y + 1) * 30 - 1) , RGB (0 , 255 , 0) , BF
			EndIf
			Draw String (x * 30 + 13 , y * 30 + 13) , charField (y , x).char , RGB (0 , 0 , 0)
		Next
	Next
End Sub

Sub mouseClick (mouse As TPoint)
	If mouse.x > 600 Then Exit Sub
	
	Dim position As TPoint
	
	For x As Integer = 0 To 19
		If (mouse.x >= x * 30) And (mouse.x < (x + 1) * 30) Then
			For y As Integer = 0 To 19
				If (mouse.y >= y * 30) And (mouse.y < (y + 1) * 30) Then
					position.x = x
					position.y = y
					Exit For
				EndIf
			Next
			Exit For
		EndIf
	Next
	
	If lastClick.x = -1 Or lastClick.y = -1 Then
		lastClick = position
		charField(lastClick.y , lastClick.x).state = TState.blocked
	ElseIf comparePoints (lastClick , position) = FALSE Then
		If position.x = lastClick.x Xor position.y = lastClick.y Then
			If position.x = lastClick.x Then 'vertical
				
				Swap position.x , position.y
				Swap lastClick.x , lastClick.y
				
				For x As Integer = 0 To 9
					If selected(x).found = TRUE Then Continue For
					
					If (comparePoints (selected(x).pos1 , lastClick) = TRUE And comparePoints (selected(x).pos2 , position) = TRUE) Or _
						(comparePoints (selected(x).pos2 , lastClick) = TRUE And comparePoints (selected(x).pos1 , position) = TRUE) Then
						selected(x).found = TRUE
						GUI.changeLabel (x + 1 , , , ,LABEL_CROSSEDOUT)
						For n As Integer = 0 To selected(x).pos2.x - selected(x).pos1.x
							charField (selected(x).pos1.x + n , selected(x).pos1.y).state = TState.blocked
							charField (selected(x).pos1.x + n , selected(x).pos1.y).locked = TRUE
						Next
						lastClick.x = -1
						lastClick.y = -1
						Exit For
					EndIf
				Next
			Else 'horizontal
				
				Swap position.x , position.y
				Swap lastClick.x , lastClick.y
				
				For x As Integer = 0 To 9
					If selected(x).found = TRUE Then Continue For
					
					If (comparePoints (selected(x).pos1 , lastClick) = TRUE And comparePoints (selected(x).pos2 , position) = TRUE) Or _
						(comparePoints (selected(x).pos2 , lastClick) = TRUE And comparePoints (selected(x).pos1 , position) = TRUE) Then
						selected(x).found = TRUE
						GUI.changeLabel (x + 1 , , , ,LABEL_CROSSEDOUT)
						For n As Integer = 0 To selected(x).pos2.y - selected(x).pos1.y
							charField (selected(x).pos1.x , selected(x).pos1.y + n).state = TState.blocked
							charField (selected(x).pos1.x , selected(x).pos1.y + n).locked = TRUE
						Next
						lastClick.x = -1
						lastClick.y = -1
						Exit For
					EndIf
				Next
			
			EndIf
		Else
			If charField (lastClick.y , lastClick.x).locked = FALSE Then charField (lastClick.y , lastClick.x).state = TState.normal
			lastClick.x = -1
			lastClick.y = -1
		EndIf
	EndIf
End Sub
