Enum Label_Style
	LABEL_NORMAL
	LABEL_CROSSEDOUT
	LABEL_NOCHANGE
End Enum
#Ifdef __FB_WIN32__
	Type TButton
		ID As UInteger
		
		x As Integer
		y As Integer
		w As Integer
		h As Integer
		label As String
		
		nextButton As TButton Ptr
	End Type
	
	Type TLabel
		ID As UInteger
		
		x As Integer
		y As Integer
		w As Integer
		h As Integer
		style As Label_Style
		label As String
		
		nextLabel As TLabel Ptr
	End Type
#Else
	Type TButton
		ID As UInteger
		
		x As Integer
		y As Integer
		w As Integer
		h As Integer
		label As String*1000
		
		nextButton As TButton Ptr
	End Type
	
	Type TLabel
		ID As UInteger
		
		x As Integer
		y As Integer
		w As Integer
		h As Integer
		style As Label_Style
		label As String*1000
		
		nextLabel As TLabel Ptr
	End Type
#EndIf
Type TGUI
	buttons As TButton Ptr
	labels As TLabel Ptr
	
	Declare Sub drawGUI
	Declare Function createLabel (pX As Integer , pY As Integer , pW As Integer , pStyle As Label_Style , pLabel As String) As UInteger
	Declare Function createButton (pX As Integer, pY As Integer , pW As Integer , pH As Integer , pLabel As String) As UInteger
	Declare Sub changeLabel (ID As UInteger , pX As Integer = -1 , pY As Integer = -1 , pW As Integer = -1 , pStyle As Label_Style = LABEL_NOCHANGE , pLabel As String = Chr (255))
	Declare Sub changeButton (ID As UInteger , pX As Integer = -1 , pY As Integer = -1 , pW As Integer = -1 , pH As Integer = -1 , pLabel As String = Chr (255))
	
	Declare Function mouse (mX As Integer , mY As Integer) As Integer
End Type


Dim Shared GUI As TGUI
GUI.buttons = 0
GUI.labels = 0


Sub TGUI.drawGUI
	If labels <> 0 Then
		Dim position As Integer
		Dim obj As TLabel Ptr
		obj = labels
		Do	
			#Ifdef __FB_WIN32__
				position = Len (obj->label)
			#Else
				position = InStr (obj->label , Chr (0))
			#EndIf
			For x As Integer = 1 To position Step obj->w
				Draw String (obj->x , obj->y + (x - 1) / obj->w * 10) , Mid (obj->label , x , obj->w) , RGB (0 , 0 , 0)
				If obj->style = LABEL_CROSSEDOUT Then
					Line (obj->x , obj->y + (x - 1) / obj->w * 10 + 4) - (obj->x + obj->w * 8 , obj->y + (x - 1) / obj->w * 10 + 4) , RGB (0 , 0 , 0)
				EndIf
			Next
			If obj->nextLabel <> 0 Then 
				obj = obj->nextLabel
			Else
				Exit Do
			EndIf
		Loop
	EndIf
	
	If  buttons <> 0 Then
		Dim obj As TButton Ptr
		obj = buttons
		Do
			Line (obj->x , obj->y) - (obj->x + obj->w , obj->y + obj->h) , RGB (0 , 0 , 0) , B
			Draw String (obj->x + 2 , obj->y + 2) , obj->label , RGB (0 , 0 , 0)
			If obj->nextButton <> 0 Then 
				obj = obj->nextButton
			Else
				Exit Do
			EndIf
		Loop
	EndIf
End Sub

Function TGUI.createLabel (pX As Integer , pY As Integer , pW As Integer , pStyle As Label_Style , pLabel As String) As UInteger
	Dim ID As UInteger
	If labels = 0 Then
		ID = 1
		labels = Allocate (SizeOf (TLabel))
		labels->ID = ID
		labels->x = pX
		labels->y = pY
		labels->w = pW
		labels->style = pStyle
		labels->label = pLabel
		labels->nextLabel = 0
	Else
		Dim obj As TLabel Ptr
		Dim newLabel As TLabel Ptr
		newLabel = Allocate (SizeOf (TLabel))
		newLabel->x = pX
		newLabel->y = pY
		newLabel->w = pW
		newLabel->style = pStyle
		newLabel->label = pLabel
		newLabel->nextLabel = 0
		
		obj = labels
		Do
			If obj->nextLabel = 0 Then
				newLabel->ID = obj->ID + 1
				ID = obj->ID + 1
				obj->nextLabel = newLabel
				Exit Do
			Else
				obj = obj->nextLabel
			EndIf
		Loop
	EndIf
	
	Return ID
End Function

Function TGUI.createButton (pX As Integer, pY As Integer , pW As Integer , pH As Integer , pLabel As String) As UInteger
	Dim ID As UInteger
	If buttons = 0 Then
		ID = 1
		buttons = Allocate (SizeOf (TButton))
		buttons->ID = ID
		buttons->x = pX
		buttons->y = pY
		buttons->w = pW
		buttons->h = pH
		buttons->label = pLabel
		buttons->nextButton = 0
	Else
		Dim obj As TButton Ptr
		Dim newButton As TButton Ptr
		newButton = Allocate (SizeOf (TButton))
		newButton->x = pX
		newButton->y = pY
		newButton->w = pW
		newButton->h = pH
		newButton->label = pLabel
		newButton->nextButton = 0
		
		Do
			If obj->nextButton = 0 Then
				ID = obj->ID + 1
				newButton->ID = ID
				obj->nextButton = newButton
				Exit Do
			Else
				obj = obj->nextButton
			EndIf
		Loop
	EndIf
	Return ID
End Function

Sub TGUI.changeLabel (ID As UInteger , pX As Integer = -1 , pY As Integer = -1 , pW As Integer = -1 , pStyle As Label_Style = LABEL_NOCHANGE , pLabel As String = Chr (255))
	If labels = 0 Then Exit Sub
	
	Dim obj As TLabel Ptr
	obj = labels
	
	Do
		If obj->ID = ID Then
			If pX <> -1 Then obj->x = pX
			If pY <> -1 Then obj->y = pY
			If pW <> -1 Then obj->w = pW
			If pStyle <> LABEL_NOCHANGE Then obj->style = pStyle
			If pLabel <> Chr (255) Then 
				obj->label = ""
				obj->label = pLabel
			EndIf
			Exit Sub
		Else
			If obj->nextLabel = 0 Then Exit Sub
			obj = obj->nextLabel
		EndIf
	Loop
End Sub

Sub TGUI.changeButton (ID As UInteger , pX As Integer = -1 , pY As Integer = -1 , pW As Integer = -1 , pH As Integer = -1 , pLabel As String = Chr (255))
	If buttons = 0 Then Exit Sub
	
	Dim obj As TButton Ptr
	obj = buttons
	
	Do
		If obj->ID = ID Then
			If pX <> -1 Then obj->x = pX
			If pY <> -1 Then obj->y = pY
			If pW <> -1 Then obj->w = pW
			If pH <> -1 Then obj->h = pH
			If pLabel <> Chr (255) Then 
				obj->label = ""
				obj->label = pLabel
			EndIf
			Exit Sub
		Else
			If obj->nextButton = 0 Then Exit Sub
			obj = obj->nextButton
		EndIf
	Loop
End Sub

Function TGUI.mouse (mX As Integer , mY As Integer) As Integer
	Dim btnID As UInteger
	Dim obj As TButton Ptr
	obj = buttons
	Do
		If mx > obj->x And mx <= obj->x + obj->w And my > obj->y And my <= obj->y + obj->h Then
			btnID = obj->ID
			Exit Do
		EndIf
		If obj->nextButton <> 0 Then
			obj = obj->nextButton
		Else
			Exit Do
		EndIf
	Loop
	
	Return btnID
End Function
